%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Test MEMORY:                                                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                        %
% A simple test to evaluate the amount of memory that is used when a    %
% term is built.                                                        %
%                                                                       %
%                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%% The goals considered in the experiments %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%
g0 :- 
      garbage_collect, nogc,
      statistics(global_stack,[Bytes,_]), write(Bytes),
      nl.

%%%%% Cost of building a variable and binding it to an other variable
g1 :- 
      garbage_collect, nogc,
      _ =_,
      statistics(global_stack,[Bytes,_]), write(Bytes),
      nl.

%%%%% Cost of building a constant and binding it to a variable
g2 :- 
      garbage_collect, nogc,
      _ = 0,
      statistics(global_stack,[Bytes,_]), write(Bytes),
      nl.

%%%%% Cost of building an unary term and binding it to a variable
g3 :- 
      garbage_collect, nogc,
      _ = f(_), 
      statistics(global_stack,[Bytes,_]), write(Bytes),
      nl.

%%%%% Cost of building a binary term and binding it to a variable
g4 :- 
      garbage_collect, nogc,
      _ = f(_, _), 
      statistics(global_stack,[Bytes,_]), write(Bytes),
      nl.


%%%%% Cost of building some terms and binding them to a variable
g5 :- 
      garbage_collect, nogc,
      _ = f(X, Y, Z), X = a, Y = g(_), Z = h(_, _),
      statistics(global_stack,[Bytes,_]), write(Bytes),
      nl.


allgoals :- g0, nl, nl,
            g1, g2, g3, g4, g5, nl.



