--import System
--import Char

data AST = Num String | Bin Char AST AST

expression X0 R
  | A1 =:= term X0 X1 &> 
    '+':X2 =:= X1 &> 
    A2 =:= expression X2 R
  = Bin '+' A1 A2 where X1, X2, A1, A2 free
expression X0 R
  | A1 =:= term X0 X1 &> 
    '-':X2 =:= X1 &> 
    A2 =:= expression X2 R
  = Bin '-' A1 A2 where X1, X2, A1, A2 free
expression X0 X1 = term X0 X1 

term X0 X2
   | X:X1 =:= takeWhile isDigit X0 &> X0 =:= X:X1 ++ X2
   = Num (X:X1) 
   | X0 =:= '(':Y0 
   = expression Y0 (')':X2)
     where Y0, X, X1 free

test1 = expression "1" []
test2 = expression "1+2" []
test3 = expression "(2-1)" []
test4 = expression "1-(2+3)-4" []
test5 = expression "(((5)))" []
test6 = expression "5-((2)+3+(4+5))" []


--- input = "(5-((2)+3+(4+5))+5-((2)+3+(4+5)))-(5-((2)+3+(4+5))+5-((2)+3+(4+5)))"
--- bench = evalSpace (expression input [])
bench = evalSpace (test3)


